#extension GL_OES_EGL_image_external : require
precision mediump float;
precision mediump int;

varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;

vec2 LensCenter = vec2(0.5, 0.5);
vec2 ScreenCenter = vec2(0.5, 0.5);
vec2 Scale = vec2(1.0, 1.0);
vec2 ScaleIn = vec2(1.0, 1.0);
vec4 HmdWarpParam = vec4(1.0, 0.22, 0.24, 0.0);

vec2 HmdWarp(vec2 texIn)
{
   vec2 theta = (texIn - LensCenter) * ScaleIn;
   float rSq = theta.x * theta.x + theta.y * theta.y;
   vec2 theta1 = theta * (HmdWarpParam.x + HmdWarpParam.y * rSq + HmdWarpParam.z * rSq * rSq + HmdWarpParam.w * rSq * rSq * rSq);
   return LensCenter + Scale * theta1;
}

void main() {
   vec2 tc = HmdWarp(vTextureCoord.xy);
   if (any(notEqual(clamp(tc, ScreenCenter-vec2(0.25,0.5), ScreenCenter+vec2(0.25, 0.5)) - tc, vec2(0.0, 0.0))))
   		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
   else
   		gl_FragColor = texture2D(sTexture, tc);
}